% Copyright Pieter Abbeel
%

function draw_likelihood_field(lf, xy_res)


%NOTE: this draws the likelihood field a bit "off" ; feel free to come up
%with a better drawing function; in particular it draws the likelihood
%field for, let's say (0.25, 0.25) into the entire square with corners:
%(0.25,0.25), (0.25, 0.50), (0.50, 0.50), (0.50, 0.25) --- i.e., the
%greyness of a square reflects the value at its bottom left corner



[m,n] = size(lf);

lf = lf/max(max(lf));

hold on; axis equal;

for i=1:m
    for j=1:n
        draw_rectangle((i-1)*xy_res(1), i*xy_res(1), (j-1)*xy_res(2), j*xy_res(2), lf(i,j));
    end
end




function draw_rectangle(x0, x1, y0, y1, filled)


if(filled)
    fill([x0 x1 x1 x0], [y0 y0 y1 y1], (1-filled)*[1 1 1] + filled*[0 0 0]);
else
    %fill([x0 x1 x1 x0], [y0 y0 y1 y1], 'w');
end
