% Copyright Pieter Abbeel
%
% 3.3 Laser Beam Sensor Model: Sampling
%
% My code runs in a few seconds.
%

% clear workspace, command window, close all images:
clear; clc; close all;


load simple_world


% 3 poses to run laser for:
% ONLY hand in plots for s0{2}, others are good for debugging your laser
% model
s0{1} = [1.5; 2.5; 0];
s0{2} = [3.5; 3.5; pi];
s0{3} = [2.5; 8.0; -pi/4];

% laser models:
% model 1: "realistic"
laser_model{1}.p_hit = 0.95;
laser_model{1}.p_short = 0.02;
laser_model{1}.p_max = 0.02;
laser_model{1}.p_rand = 0.01;
laser_model{1}.sigma_hit = 0.05;
laser_model{1}.lambda_short = 1;
laser_model{1}.z_max = 20;
laser_model{1}.z_max_eps = 0.02;
laser_model{1}.laser_angles = -pi: (pi/20) : pi;

% model 2: noise free 
laser_model{2}.p_hit = 1.0;
laser_model{2}.p_short = 0;
laser_model{2}.p_max = 0;
laser_model{2}.p_rand = 0;
laser_model{2}.sigma_hit = 0;
laser_model{2}.lambda_short = 1;
laser_model{2}.z_max = 20;
laser_model{2}.z_max_eps = 0.02;
laser_model{2}.laser_angles = -pi: (pi/20) : pi;

% model 3: always short
laser_model{3}.p_hit = 0.0;
laser_model{3}.p_short = 1.0;
laser_model{3}.p_max = 0;
laser_model{3}.p_rand = 0;
laser_model{3}.sigma_hit = 0;
laser_model{3}.lambda_short = 1;
laser_model{3}.z_max = 20;
laser_model{3}.z_max_eps = 0.02;
laser_model{3}.laser_angles = -pi: (pi/20) : pi;

% model 4: always max
laser_model{4}.p_hit = 0;
laser_model{4}.p_short = 0;
laser_model{4}.p_max = 1.0;
laser_model{4}.p_rand = 0;
laser_model{4}.sigma_hit = 0;
laser_model{4}.lambda_short = 1;
laser_model{4}.z_max = 20;
laser_model{4}.z_max_eps = 0.02;
laser_model{4}.laser_angles = -pi: (pi/20) : pi;

% model 5: always random
laser_model{5}.p_hit = 0;
laser_model{5}.p_short = 0;
laser_model{5}.p_max = 0;
laser_model{5}.p_rand = 1.0;
laser_model{5}.sigma_hit = 0;
laser_model{5}.lambda_short = 1;
laser_model{5}.z_max = 20;
laser_model{5}.z_max_eps = 0.02;
laser_model{5}.laser_angles = -pi: (pi/20) : pi;




for laser_model_idx =1:length(laser_model)
	for pose_idx = 1:length(s0)
		s = s0{pose_idx};
		z = beam_range_finder_sampler_gridworld(s(1), s(2), s(3), gridworld, laser_model{laser_model_idx});%%YOU need to implement this function
		figure; draw_gridworld(gridworld); axis equal; hold on;
		plot(s(1), s(2), 'x');
		for k=1:length(z)
			plot([s(1) s(1)+z(k)*cos(s(3)+laser_model{laser_model_idx}.laser_angles(k))], [s(2) s(2)+z(k)*sin(s(3)+laser_model{laser_model_idx}.laser_angles(k))],'r-');
		end
	end
end



